classification
Title: enum _sunder_ names mix metaclass and enum class attributes
Type: Stage: resolved
Components: Documentation Versions: Python 3.8, Python 3.7, Python 3.6, Python 3.4, Python 3.5
process
Status: closed Resolution: not a bug
Dependencies: Superseder:
Assigned To: ethan.furman Nosy List: Gerrit.Holl, docs@python, ethan.furman, inada.naoki, xtreak
Priority: normal Keywords:

Created on 2018-08-24 14:44 by Gerrit.Holl, last changed 2018-09-10 17:50 by ethan.furman. This issue is now closed.

Messages (3)
msg324003 - (view) Author: Gerrit Holl (Gerrit.Holl) * Date: 2018-08-24 14:44
In the [`enum` module](https://docs.python.org/3/library/enum.html#supported-sunder-names) documentation, some of the `_sunder_` names are on `EnumMeta`, whereas others are on the produced `Enum` class:

> 8.13.15.3.2. Supported `_sunder_` names

> * `_name_` – name of the member
> * `_value_` – value of the member; can be set / modified in __new__
> * `_missing_` – a lookup function used when a value is not found; may be overridden
> * `_ignore_` – a list of names, either as a list() or a str(), that will not be transformed into members, and will be removed from the final class
> * `_order_` – used in Python 2/3 code to ensure member order is consistent (class attribute, removed during class creation)
> * `_generate_next_value_` – used by the Functional API and by auto to get an appropriate value for an enum member; may be overridden

Experimentally, it appears `_name_` and `_value_` are on the `Enum` class, whereas the others are all on the `EnumMeta` class:

In [272]: class Test(enum.Enum): a = 0

In [273]: Test.a._name_
Out[273]: 'a'

In [274]: Test._name
---------------------------------------------------------------------------
AttributeError                            Traceback (most recent call last)
<ipython-input-274-8d4f758e0fb7> in <module>()
----> 1 Test._name

/group_workspaces/cems2/fiduceo/Users/gholl/anaconda3/envs/FCDR37a/lib/python3.7/enum.py in __getattr__(cls, name)
    344             return cls._member_map_[name]
    345         except KeyError:
--> 346             raise AttributeError(name) from None
    347 
    348     def __getitem__(cls, name):

AttributeError: _name

In [275]: Test.a._value_
Out[275]: 0

In [276]: Test._value
---------------------------------------------------------------------------
AttributeError                            Traceback (most recent call last)
<ipython-input-276-a1cd5032d83d> in <module>()
----> 1 Test._value

/group_workspaces/cems2/fiduceo/Users/gholl/anaconda3/envs/FCDR37a/lib/python3.7/enum.py in __getattr__(cls, name)
    344             return cls._member_map_[name]
    345         except KeyError:
--> 346             raise AttributeError(name) from None
    347 
    348     def __getitem__(cls, name):

AttributeError: _value

In [277]: Test.a._missing_
Out[277]: <bound method Enum._missing_ of <enum 'Test'>>

In [278]: Test._missing_
Out[278]: <bound method Enum._missing_ of <enum 'Test'>>


This is not clear from the documentation.
msg324165 - (view) Author: Inada Naoki (inada.naoki) * (Python committer) Date: 2018-08-27 10:39
Is it really need to be documented?
How is it important when using enum?

If there are no problem, I prefer keeping it implementation detail and don't make document fatter.
msg324202 - (view) Author: Ethan Furman (ethan.furman) * (Python committer) Date: 2018-08-27 22:27
All those attributes live in the Enum class.  If you use a non-existent attribute, such as _name, then the metaclass will be called to check if that name is actually an Enum member.
History
Date User Action Args
2018-09-10 17:50:48ethan.furmansetstatus: open -> closed
resolution: not a bug
stage: resolved
2018-08-27 22:27:19ethan.furmansetassignee: docs@python -> ethan.furman

messages: + msg324202
nosy: + ethan.furman
2018-08-27 10:39:40inada.naokisetnosy: + inada.naoki
messages: + msg324165
2018-08-27 08:28:33xtreaksetnosy: + xtreak
2018-08-24 14:44:31Gerrit.Hollcreate